part of tecfy_core_client_package;

class EntityAction {
  /// action arabic name
  late String nameAr;
  String? overwriteProperties;

  /// action english name
  late String nameEn;
  String get name => LocalConfigService.isArabic ? nameAr : nameEn;
  late String dbName;
  String? icon;
  dynamic modal;
  late List<Property> actionFormProp;
  dynamic actionForm;
  // String showWhen ;
  // String permissionParameter;

  EntityAction.fromMap(Map<String, dynamic> row) {
    nameAr = row['nameAr'];
    nameEn = row['nameEn'];
    overwriteProperties = row['overwriteProperties'];
    icon = row['icon'];
    viewFormula = row['viewFormula'];
    dbName = lowerFirst(row['dbName']);
    // showWhen = row['showWhen'];
    // permissionParameter = row['permissionParameter'];

    // if(row['permission'] != null)
    //   permission = Permission.fromMap(row['permission']);

    if (row['actionFormProp'] != null) {
      actionFormProp = row['actionFormProp']
          .map<Property?>((p) => Property.getProperty(p))
          .where((e) => e != null)
          .map<Property>((e) => e as Property)
          .toList();
    } else {
      actionFormProp = [];
    }
  }

  String? viewFormula;
  Expression? viewFormulaExp;
  List<Variable>? viewFormulaExpVariables;

  bool isVisible(Map<String, dynamic> data, List<Property> entityProperties) {
    if (viewFormula != null && (viewFormula ?? '').isNotEmpty) {
      var params = Map<String, dynamic>();
      for (var i in viewFormula?.split(',').sublist(1) ?? []) {
        params[i.replaceAll('.', '')] =
            ValuesService.getValueByStringEx(i, data, entityProperties);
      }
      return getViewFormulaResult(params);
    }
    return true;
  }

  bool getViewFormulaResult(Map<String, dynamic> vars) {
    try {
      var fString = viewFormula?.split(',').first.replaceAll('.', '') ?? '';
      var f = Expression.parse(fString);
      final evaluator = const ExpressionEvaluator();
      var r = evaluator.eval(f, vars);
      return r;
    } catch (err) {
      print('XXXXXXXXXX getViewFormulaResult $err');
      return false;
    }
  }

  /// lower the fist letter
  String lowerFirst(String s) {
    if (s.isEmpty) return '';
    return '${s[0].toLowerCase()}${s.substring(1)}';
  }
}
